#include "Backbuffer.h"
#include "FramebufferDevice.h"

Backbuffer::Backbuffer(unsigned int XRes, unsigned int YRes)
{
	buffer = new unsigned char[XRes * YRes * 3]; // 24bpp fixed
	xres = XRes;
	yres = YRes;
}

Backbuffer::~Backbuffer()
{
	delete[] buffer;
}

void Backbuffer::setPixel(unsigned int X, unsigned int Y, unsigned char red, unsigned char green, unsigned char blue)
{
	if (X > xres || Y > yres) return;
	unsigned int p = (Y * xres + X) * 3;
	buffer[p] = blue;
	buffer[p + 1] = green;
	buffer[p + 2] = red;
}

void Backbuffer::Project(FramebufferDevice* dev)
{
	memcpy(dev->fb, buffer, xres * yres * 3);
}

void Backbuffer::setEmpty()
{
	memset(buffer, 0, xres * yres * 3);
}

int Backbuffer::getHeight()
{
	return yres;
}

int Backbuffer::getWidth()
{
	return xres;
}
